<?php
/*
 * SP highlighting plugin
 *
 *  Jorge López Pérez <jorgelp@us.es>
 *  6/mar/2008
 */

/*
 * Highlight function
 */

function shib13sp_highlight($line) {
	$pattern = '/^(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}) (\w+) ([\w.-]+) (\[\d+\]|:) (.+)$/';

	$match = preg_match($pattern, $line, $pieces);
	if ($match > 0 && $match !== FALSE) {
	  $line = '<span class="logtimestamp">'.$pieces[1].'</span> ';
	  $line .= '<span class="log'.strtolower($pieces[2]).'">'.$pieces[2].'</span> ';
	  $line .= '<span class="logsource">'.$pieces[3].'</span> ';
	  $line .= '<span class="logadditional">'.$pieces[4].'</span> ';

	  // More changes
	  $rest = $pieces[5];
	  $subpatterns = array(
		  // IDs
		  '/(\((ID(=|:\s))?_([\w\d]+)\))/',
		  // URNs
		  '/(urn:[\w0-9\.:-]+)/',
		  // IPs
		  '/(\d+\.\d+\.\d+\.\d+)/',
		  // URLs
		  '/(http[s]?:\/\/[\w0-9\.\/-]+(:\d+)?[\w0-9\.\/-]+)/'
		  );
	  $changes = array(
		  '<span class="logid">\1</span>',
		  '<span class="logurn">\1</span>',
		  '<span class="logip">\1</span>',
		  '<span class="logurl">\1</span>',
		  );
	  $rest = preg_replace($subpatterns, $changes, $rest);

	  $line .= '<span class="logrest">'.$rest.'</span> ';
	}

	return $line;

}


?>
