<?php

require_once('config.inc.php');
require_once('Highlight.php');

class FrontendWeb {

	private $backend;

	public function __construct($pieces) {
		$this->backend = new Backend();
	}

	function process() {
		?>
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
 <head>
	<title>Log viewer</title>
   <style type="text/css" media="all">@import "style.css";</style>
   	<script language="javascript" type="text/javascript"
	 src="js/jquery-1.2.2.min.js"> </script>
	<script language="javascript" type="text/javascript"
	 src="js/logs.js"> </script>
	<script language="javascript" type="text/javascript"
	 src="js/jquery.scrollTo-min.js"> </script>
 </head>
 <body>
 <h1>Log Viewer</h1>
 <?php $this->showLogs(); ?>
 <?php footer(); ?>
 </body>
</html>
<?php
	}


	/*
	 * Show logs
	 */

	function showLogs() {
		global $sources;

		foreach ($sources as $id => $data) {
			echo $this->loginterface($id, $data);
		}
	}
	
	/*
	 * Show interfaces
	 */
	function loginterface($id, $data) {
		global $defaultlines;

	?>
	   <h2><?php echo $data['title']; ?></h2>
	   <div id="<?php echo $id ?>" class="log">
		<div id="<?php echo $id?>-content">
	<?php 
		echo Highlight::doHighlight($this->backend->readlog($id,
					$defaultlines), $data['generator']);
	?>
	   </div>
	   <a name="bottom<?php echo $id ?>" id="bottom<?php echo $id ?>"></a>
	   </div>
	   <form action="<?php echo $_SERVER['SCRIPT_NAME'] ?>" method="get">
		<label for="<?php echo $id ?>lines">Lines to show:</label>
		<input type="text" class="inputlines" name="<?php echo $id
		?>lines" id="<?php echo $id ?>_lines" 
		maxlength="4" size="4" value="<?php echo $defaultlines; ?>" />
		<input type="submit" name="<?php echo $id ?>linessubmit" id="<?php echo $id ?>linessubmit"
		class="changelinesbutton" value="Change" />
	   <span><a id="refresh_<?php echo $id ?>" class="refresh" href="#bottom<?php echo $id ?>">refresh</a></span>
	   </form>


	<?php
	}


}

?>
